package com.steerinfo.appservice.appmeterbasecussupcar.controller;

import com.steerinfo.appservice.appmeterbasecussupcar.model.AppMeterBaseCusSupCar;
import com.steerinfo.appservice.appmeterbasecussupcar.service.IAppMeterBaseCusSupCarService;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.util.StringUtils;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;

/**
 * MeterBaseCusSupCar RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-06-15 11:47
 * 类描述
 * 修订历史：
 * 日期：2020-06-15
 * 作者：generator
 * 参考：
 * 描述：MeterBaseCusSupCar RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/appservice/meterbasecussupcars")
public class AppMeterBaseCusSupCarController extends BaseRESTfulController {

    @Autowired
    IAppMeterBaseCusSupCarService appMeterBaseCusSupCarService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<AppMeterBaseCusSupCar> list = appMeterBaseCusSupCarService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterBaseCusSupCar对象创建")
    @Transactional
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody AppMeterBaseCusSupCar model) {
        try {
            String msg = appMeterBaseCusSupCarService.checkandadd(model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }


    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterBaseCusSupCar信息来更新详细信息")
    @Transactional
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody AppMeterBaseCusSupCar model) {
        try {
            String msg = appMeterBaseCusSupCarService.checkandupdate(id, model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "App端获取有效车辆列表", notes = "分页查询")
    @GetMapping(value = "/selectCar")
    public RESTfulResult selectCar(@RequestParam HashMap parmas) {
        try {
            List<AppMeterBaseCusSupCar> list = appMeterBaseCusSupCarService.selectCar(parmas);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "App端获取所有车辆列表", notes = "分页查询")
    @GetMapping(value = "/selectAllCar")
    public RESTfulResult selectAllCar(@RequestParam HashMap parmas) {
        try {
            List<AppMeterBaseCusSupCar> list = appMeterBaseCusSupCarService.selectAllCar(parmas);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

}
